package default_hash_code;

import static org.junit.Assert.*;

import java.util.Hashtable;

import org.junit.Test;

public class TestIntegerKey {

	@Test
	public void testDefaultHashFunction() {
		IntegerKey ik39_1 = new IntegerKey(39);
		IntegerKey ik39_2 = new IntegerKey(39);
		assertTrue(ik39_1.equals(ik39_2));
		/* Violation of principle: 
		 * k1.equals(k2) ==> k1.hashCode() == k2.hashCode()
		 * Issue: without overriding hashCode(),
		 * a different number is generated for every new object,
		 * regardless of their contents.
		 */
		assertTrue(ik39_1.hashCode() != ik39_2.hashCode());
	}
	
	@Test
	public void testHashTable() {
		Hashtable<IntegerKey, String> table = new Hashtable<>();
		IntegerKey k1 = new IntegerKey(39);
		IntegerKey k2 = new IntegerKey(39);
		assertTrue(k1.equals(k2));
		assertTrue(k1.hashCode() != k2.hashCode());
		table.put(k1, "D");
		assertTrue(table.get(k2) == null);
	}
}
